'*******************************************************************************
'*                           TControlCanvas.bi                                 *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                           version 2.0                                       *
'*******************************************************************************

#include once "graphics.bi"
#include once "control.bi"

#define TControlCanvasClass(__Ptr__) *cast(TControlCanvas ptr,__Ptr__)

type PControlCanvas as TControlCanvas ptr
type TControlCanvas
    private:
    AControl as PControl
    FDc      as hdc
    FFont    as hfont
    FBrush   as hbrush
    FPen     as hpen
    FKeepDC  as integer
    declare sub LockCanvas
    declare sub UnlockCanvas
    public:
    Clip     as integer
    Font     as TFont
    Pen      as TPen
    Brush    as TBrush
    Tag      as any ptr
    declare property Control as TControl ptr
    declare property Control(value as TControl ptr)
    declare property Dc as HDC
    declare property Dc(value as HDC)
    declare property KeepDc as integer
    declare property KeepDc(value as integer)
    declare sub MoveTo(x as integer,y as integer)
    declare sub LineTo(x as integer,y as integer)
    declare sub Line(x as integer,y as integer,x1 as integer,y1 as integer)
    declare sub Rectangle(x as integer,y as integer,x1 as integer,y1 as integer)
    declare sub Rectangle(R as Rect)
    declare sub RoundRect(x as integer,y as integer,x1 as integer,y1 as integer,cx as integer,cy as integer)
    declare sub RoundRect(R as Rect,cx as integer,cy as integer)
    declare sub Ellipse(x as integer,y as integer,x1 as integer,y1 as integer)
    declare sub Ellipse(R as Rect)
    declare sub Polygon(Points as Point ptr,Count as integer) 
    declare sub Pie(x as integer,y as integer,x1 as integer,y1 as integer,nXRadial1 as integer,nYRadial1 as integer,nXRadial2 as integer,nYRadial2 as integer)
    declare sub Arc(x as integer,y as integer,x1 as integer,y1 as integer,xStart as integer, yStart as integer,xEnd as integer,yEnd as integer)
    declare sub ArcTo(x as integer,y as integer,x1 as integer,y1 as integer,nXRadial1 as integer,nYRadial1 as integer,nXRadial2 as integer,nYRadial2 as integer)
    declare sub AngleArc(x as integer,y as integer,Radius as integer,StartAngle as single,SweepAngle as single)
    declare sub Chord(x as integer,y as integer,x1 as integer,y1 as integer,nXRadial1 as integer,nYRadial1 as integer,nXRadial2 as integer,nYRadial2 as integer)
    declare sub Polyline(Points as Point ptr,Count as integer)
    declare sub PolylineTo(Points as Point ptr,Count as integer)
    declare sub PolyBeizer(Points as Point ptr,Count as integer)
    declare sub PolyBeizerTo(Points as Point ptr,Count as integer)
    declare sub SetPixel(x as integer,y as integer,PixelColor as integer)
    declare function GetPixel(x as integer,y as integer) as integer
    declare sub TextOut(x as integer,y as integer,Text as string,BackClr as integer=-1)
    declare sub TextRect(R as Rect,Text as string,Flags as integer=0)
    declare sub DrawFocusRect(R as Rect)
    declare sub Draw(x as integer,y as integer,Bitmap as TBitmap)
    declare sub DrawTransparent(x as integer,y as integer,Bitmap as TBitmap)
    declare sub FillRect(R as Rect)
    declare function TextHeight(Text as string) as integer
    declare function TextWidth(Text as string) as integer
    declare operator cast as any ptr
    declare operator cast as string
    declare constructor(CanvasControl as TControl ptr=0)
    declare destructor
end type
