'*******************************************************************************
'*                             IDesigner.bas                                   *
'*             This file is a part of sGUI libary for FreeBasic                *
'*             Copyright 2010-2013 Nastasa Vasile Eodor                       *
'*             http://sgui.rqwork.evonet.ro                                    *
'*             mail: nastase.eodor@gmail.com                                   *
'*                             version 2.0                                     *
'*******************************************************************************

#include once "control.bi"
#include once "classes.bi"

#define TDesignerGridClass(__Ptr__)          *cast(TDesignerGrid ptr,__Ptr__)
#define TDesignerNameAllocatorClass(__Ptr__) *cast(TDesignerNameAllocator ptr,__Ptr__)
#define TDesignerClass(__Ptr__)              *cast(TDesigner ptr,__Ptr__)

enum TDrawBoxKind
    bkDot,bkSolid
end enum

enum TDesignerHint
    dhNone,dhControl,dhSize,dhMove
end enum

type TDesignerGrid
    private:
    FYStep   as integer
    FXStep   as integer
    FColor   as integer
    FVisible as integer
    declare sub Draw
    public:
    declare constructor(IDesigner as PDesigner)
    declare destructor
    declare operator cast as any ptr
    declare operator cast as string
end type

type TDesignerNameAllocator
    private:
    FNames as TList
    public:
    declare property Name(index as integer) as string
    declare property Name(index as integer,value as string)
    declare operator cast as any ptr
    declare operator cast as string
    declare constructor(IDesigner as PDesigner)
    declare destructor
    declare sub StoreName overload(AName as integer)
    declare sub StoreName(AControl as PControl)
    declare function Add(AControl as PControl) as string
    declare function NameExists(AName as string) as integer
end type

type TDesigner
    private:
    FSelectedControls as PList
    FDesignControl    as PControl
    FDefaultControl   as PControl
    FSnapToGrid       as integer
    declare sub DispatchMessage(byref message as TMessage)
    declare sub ProcessMessage(byref message as TMessage)
    declare sub SelectionBox(AKind as TDrawBoxKind=bkSolid)
    declare sub SelectControls(ARect as Rect)
    declare sub DrawBoxes(AVisible as integer=1)
    declare sub DrawHandles(AVisible as integer=1)
    declare sub MoveControls
    declare sub ReziseControl(AControl as TControl ptr)
    declare sub DeleteControl(AControl as TControl ptr)
    public:
    declare constructor(IForm as TControl ptr)
    declare destructor
    declare operator cast as any ptr
    declare operator cast as string
    declare function FindControl(AControlName as string) as TControl ptr
    declare function CanUndo as integer
    declare function CanRedo as integer
    declare function CanCut as integer
    declare function CanCopy as integer
    declare function CanPaste as integer
    declare sub Lock(AControl as TControl ptr)
    declare sub SelectAll
    declare sub Update
    declare sub Invalidate
end type
